#<profile4xi profile = "03" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "_c4xi.py">
#<abstract4xi abstract = "provides classes _C and _C4Xi"/>
#<refer4xi reference = "forking.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['_C', '_C4Xi'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi   

import signal
from pickle import _Pickler as Pickler
   
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
from multiprocessing import forking
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from forkingpickler4xi import ForkingPickler4Xi
from print4xi import print4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi

from _reduce_method4xi import _reduce_method4xi
#"
#/>


# =================================================================================================
#<class4xi class = "C" base = "None" child = "None" synopsis = "C class" usage = "
#   forking.py
#       ForkingPickler.register(type(_C().f), _reduce_method)
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================       
class _C:
    '''
    ForkingPickler4Xi.register(type(_C().f), _reduce_methodxi)
    
    '''
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "f" usage = "f method">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def f(self):
        '''
        acts as a dummy function
        '''
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
                
        class2print = "_C"
        method2print = "f"
    
        message2print = "{started" + "; function-dummy-of-C-started: " + str(f)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
         
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
    
        pass
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{returning" + "; function-dummy-of-C-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                                
                        
                                              
    #</methodize4xi>
#</class4xi>


# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ForkingPickler4Xi.register(type(_C().f), _reduce_method4xi)
#"
#"/>

# =================================================================================================
#<class4xi class = "C4Xi" base = "None" child = "None" synopsis = "C4Xi class" usage = "
#   forking4xi.py
#       ForkingPickler4Xi.register(type(_C4Xi().f), _reduce_method4xi)
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================                 
class _C4Xi: #<--- note that this class has no ()
    '''
    pickling
    '''
    

      
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "f" usage = "f method">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def f(self):
        '''
        f method
        '''
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
                
        class2print = "_C4Xi"
        method2print = "f"

    
        message2print = "{started" + "; function-dummy-of-C4Xi-started: " + str(f)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                 
        
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
            
        pass
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------              
        message2print = "{returning" + "; function-dummy-of-C4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                        
    #</methodize4xi>
              
    

                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-C4Xi" usage = "senses _C4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses _C4Xi class objects
        '''

        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
          
        
        class2print = '_C4Xi'
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-C4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; C4Xi-sensing-by-sense-of-C4Xi: " + str(_C4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                   
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-C4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
    
        
        
      
        message2print = "{sensed" + "; C4Xi-sensed-by-sense-of-C4Xi: " + str(_C4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-C4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                             
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-C4Xi" usage = "reasons _C4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons _C4Xi class objects
        '''

        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
                 
        
        class2print = '_C4Xi'
        method2print = 'reason'

        
        message2print = "{started" + "; reason-of-C4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; C4Xi-reasoning-by-reason-of-C4Xi: " + str(_C4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-C4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; C4Xi-reasoned-by-reason-of-C4Xi: " + str(_C4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-C4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                        
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-C4Xi" usage = "aces _C4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces _C4Xi class objects 
        '''

        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
        class2print = '_C4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-C4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
            
   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; C4Xi-acing-by-ace-of-C4Xi: " + str(_C4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                   
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-C4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; C4Xi-aced-by-ace-of-C4Xi: " + str(_C4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8x-returning-by-ace-of-C4Xi: " + str(kb8x) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                            
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ForkingPickler4Xi.register(type(_C4Xi().f), _reduce_method4xi)
#"
#"/>

#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_c4xi.txt
#   sense-test-c4xi.xml
#   reason-test-c4xi.xml
#   ace-test-c4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of _c4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

 